
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2014 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title SUB (register)

@encoding(t1) {

    @half 0 0 0 1 1 0 1 Rm(3) Rn(3) Rd(3)

    @syntax <Rd> <Rn> <Rm>

    @conv {

        Rd = Register(Rd)
        Rn = Register(Rn)
        Rm = Register(Rm)

    }

}

@encoding(T2) {

    @word 1 1 1 0 1 0 1 1 1 0 1 S(1) Rn(4) 0 imm3(3) Rd(4) imm2(2) type(2) Rm(4)

    @syntax {S} <Rd> <Rn> <Rm> <?shift>

    @conv {

        S = SetFlags(S)
        Rd = Register(Rd)
        Rn = Register(Rn)
        Rm = Register(Rm)
        shift = DecodeImmShift(type, imm3:imm2)

    }

    @rules {
        
        //if ((Rd == '1111') && (S == '1')) ; see CMP (register)
        //if (Rn == '1101') ; see SUB (SP minus register)
        //if ((d == 13) || ((d == 15) && (S == '0')) [[ n == 15 || (m IN {13,15})) ; unpredictable

    }

}

@encoding(A1) {

    @word cond(4) 0 0 0 0 0 1 0 S(1) Rn(4) Rd(4) imm5(5) type(2) 0 Rm(4)

    @syntax {S} {c} <Rd> <Rn> <Rm> <?shift>

    @conv {

        S = SetFlags(S)
        c = Condition(cond)
        Rd = Register(Rd)
        Rn = Register(Rn)
        Rm = Register(Rm)
        shift = DecodeImmShift(type, imm5)

    }

    @rules {

        //if (Rn == '1101') ; see SUB (SP minus register)
        //if ((Rd == '1111') && (S == '1')) ; see SUBS PC, LR and related instructions


    }

}
